# yamllint disable
# License: MIT (c) GitLab Inc.
# yamllint enable
---
rules:
- id: "python/sql/rule-hardcoded_sql_expression"
  languages:
  - "python"
  message: |
    Detected possible formatted SQL query. Use parameterized queries instead.
  metadata:
    cwe: "CWE-89"
    owasp: "A1:2017-Injection"
    shortDescription: "Improper Neutralization of Special Elements used in an SQL
      Command ('SQL Injection')"
  patterns:
  - pattern-either:
    - pattern: "$DB.execute(\"...\" % ...)"
    - pattern: "$DB.execute(\"...\".format(...))"
    - pattern: "$DB.execute(f\"...\")"
    - pattern: "$DB.execute(\"...\" + $V + \"...\")"
    - patterns:
      - pattern-either:
        - pattern-inside: |
            ...
            $SQL = "..." % ...
            ...
        - pattern-inside: |
            ...
            $SQL = $SQL + "..." % ...
            ...
        - pattern-inside: |
            ...
            $SQL = "...".format(...)
            ...
        - pattern-inside: |
            ...
            $SQL = f"...{$X}..."
            ...
      - pattern: "$DB.execute($SQL)"
  severity: "WARNING"
